//
//  ViewController.m
//  Chat_V
//
//  Created by BOBO on 16/12/2.
//  Copyright © 2016年 BOBO. All rights reserved.
//

#import "ViewController.h"
#import "Chat_Model.h"
#import "Chat_Cell.h"
#define  iphone_w [UIScreen mainScreen].bounds.size.width
#define  iphone_h [UIScreen mainScreen].bounds.size.height
#define  tool_h 54.0
@interface ViewController ()<UITableViewDelegate,UITableViewDataSource,UITextFieldDelegate>
{
    CGRect old_frame;

}
// 聊天视图
@property(strong,nonatomic)UITableView * chat_Tabv;
// 聊天数据源 (模拟)
@property(strong,nonatomic)NSMutableArray * chat_Arr;
//中间变量
@property(strong,nonatomic)Chat_Cell * temp_cell;
//聊天下面的发送 语音视图 键盘监听用
@property(strong,nonatomic)UIView  * chat_ToolV;
@property(strong,nonatomic)UITextField * chat_Txt;

@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    
    self.edgesForExtendedLayout = UIRectEdgeNone;//不会延伸至navigationBar和tabBar
    self.chat_Arr = [Chat_Model demoData].mutableCopy;
    [self.view addSubview:self.chat_Tabv];
    [self setToolV];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(keyBoardWillShow:) name:UIKeyboardWillShowNotification object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(keyBoardWillHide:) name:UIKeyboardWillHideNotification object:nil];
    
    // Do any additional setup after loading the view, typically from a nib.
}
//聊天的发送  语音等按钮
-(void)setToolV
{
    UIView * ToolV = [[UIView alloc]initWithFrame:CGRectMake(0, iphone_h - tool_h, iphone_w, tool_h)];
    UIButton * voiceBtn = [UIButton buttonWithType:UIButtonTypeCustom];
    voiceBtn.frame = CGRectMake(8, 0, 35, 35);
    [voiceBtn setImage:[UIImage imageNamed:@"ToolViewInputVoice"] forState:UIControlStateNormal];
    [voiceBtn setImage:[UIImage imageNamed:@"ToolViewInputVoiceHL"] forState:UIControlStateSelected];
    
    UIButton *sendMBtn = [UIButton buttonWithType:UIButtonTypeCustom];
    sendMBtn.frame = CGRectMake(iphone_w-40, 0, 35, 35);
    [sendMBtn setImage:[UIImage imageNamed:@"TypeSelectorBtn_Black"] forState:UIControlStateNormal];
    [sendMBtn addTarget:self action:@selector(SendTxtBtnAction:) forControlEvents:UIControlEventTouchUpInside];
    
    UIButton *emojBtn = [UIButton buttonWithType:UIButtonTypeCustom];
    emojBtn.frame = CGRectMake(iphone_w-80, 0, 35, 35);
    [emojBtn setImage:[UIImage imageNamed:@"ToolViewEmotion"] forState:UIControlStateNormal];
    [emojBtn setImage:[UIImage imageNamed:@"ToolViewEmotionHL"] forState:UIControlStateSelected];
    
    UITextField * textF = [[UITextField alloc]initWithFrame:CGRectMake(voiceBtn.frame.origin.x+voiceBtn.frame.size.width+5, 0, iphone_w-127, 35)];
    textF.placeholder = @"想说什么~";
    textF.delegate = self;
    self.chat_Txt = textF;
    
    [ToolV addSubview:voiceBtn];
    [ToolV addSubview:emojBtn];
    [ToolV addSubview:sendMBtn];
    [ToolV addSubview:textF];
    [self.view addSubview:ToolV];
    self.chat_ToolV = ToolV;
}
#pragma mark - del /dat
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return self.chat_Arr.count;
}
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{  static NSString * identify = @"chat_ID";
    Chat_Cell * cell = [tableView dequeueReusableCellWithIdentifier:identify];
    if (!cell) {
        cell = [[Chat_Cell alloc]initWithStyle:UITableViewCellStyleValue2 reuseIdentifier:identify];
        cell.selectionStyle = UITableViewCellSelectionStyleNone;
    }
    self.temp_cell = cell;
    cell.chat_M = self.chat_Arr[indexPath.row];
    
    return cell;
}
-(CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath
{
    Chat_Model * chat_Ms = [self.chat_Arr objectAtIndex:indexPath.row];
    self.temp_cell.chat_M = chat_Ms;
    return self.temp_cell.bounds.size.height;
}
-(BOOL)textFieldShouldReturn:(UITextField *)textField
{
    [self.chat_Txt  resignFirstResponder];
    return YES;
}
#pragma mark - action

/**
 键盘监听

 @param notification __通知
 */
-(void)keyBoardWillShow:(NSNotification*)notification
{
    CGRect keyboardFrame = [notification.userInfo[UIKeyboardFrameEndUserInfoKey] CGRectValue];
    
    NSTimeInterval duration = [notification.userInfo[UIKeyboardAnimationDurationUserInfoKey] doubleValue];
    UIViewAnimationOptions option = [notification.userInfo[UIKeyboardAnimationCurveUserInfoKey] intValue];
    CGFloat keyboard_H = keyboardFrame.size.height;
    __weak typeof(self)  weakself = self;
    
    [UIView animateWithDuration:duration delay:0 options:option animations:^{
        //上移键盘高度
        weakself.chat_Tabv.frame = CGRectMake(0, 64-keyboard_H, iphone_w, iphone_h-64-tool_h);
        weakself.chat_ToolV.frame = CGRectMake(0, iphone_h-tool_h-keyboard_H, iphone_w, tool_h);
    } completion:^(BOOL finished) {
        [weakself scrollToTableViewBottom];
    }];
    
}
-(void)keyBoardWillHide:(NSNotification*)notification
{
    NSTimeInterval duration = [notification.userInfo[UIKeyboardAnimationDurationUserInfoKey] doubleValue];
    UIViewAnimationOptions option = [notification.userInfo[UIKeyboardAnimationCurveUserInfoKey] intValue];
    __weak typeof(self)weakself = self;
    [UIView animateWithDuration:duration delay:0 options:option animations:^{
        weakself.chat_Tabv.frame = old_frame;
        weakself.chat_ToolV.frame = CGRectMake(0, iphone_h - tool_h, iphone_w, tool_h);
    } completion:^(BOOL finished) {
        [weakself scrollToTableViewBottom];
    }];
}
-(void)SendTxtBtnAction:(UIButton *)sender
{
    NSString *newContent = self.chat_Txt.text;
    if (newContent.length < 1) {
        return;
    }
    Chat_Model *newMessage = [[Chat_Model alloc] init];
    newMessage.content = newContent;
    newMessage.fromMe = YES;
    
    [self.chat_Arr addObject:newMessage];
    NSIndexPath *indexPath = [NSIndexPath indexPathForRow:self.chat_Arr.count - 2 inSection:0];
    NSLog(@"数组长度:%ld",self.chat_Arr.count);
    //插入数据
    [self.chat_Tabv insertRowsAtIndexPaths:@[indexPath] withRowAnimation:UITableViewRowAnimationBottom];
    [self scrollToTableViewBottom];
    self.chat_Txt.text = @"";//置空
}
// Scroll to the bottom row 滚动到最后一行
- (void)scrollToTableViewBottom {
    
    NSIndexPath *lastIndexPath = [NSIndexPath indexPathForRow:self.chat_Arr.count - 1 inSection:0];
    [self.chat_Tabv scrollToRowAtIndexPath:lastIndexPath atScrollPosition:UITableViewScrollPositionBottom animated:NO];
    
    //    [self.tableView scrollRectToVisible:CGRectMake(0, self.tableView.contentSize.height - 1, self.tableView.bounds.size.width, 1) animated:NO];
}
#pragma mark - get

-(UITableView *)chat_Tabv
{
    if (!_chat_Tabv) {
        _chat_Tabv = [[UITableView alloc]initWithFrame:CGRectMake(0, 64, iphone_w, iphone_h-64-tool_h) style:UITableViewStylePlain];
        _chat_Tabv.separatorStyle = UITableViewCellSeparatorStyleNone;
         old_frame = _chat_Tabv.frame;
        _chat_Tabv.delegate = self;
        _chat_Tabv.dataSource = self;
    }
    return _chat_Tabv;
}

-(NSMutableArray *)chat_Arr
{
    if (!_chat_Arr) {
        _chat_Arr = [NSMutableArray array];
    }
    return _chat_Arr;
}
- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}
@end
